<?php
if (isset($_GET["search"])) {
	sleep(5);
}
$version = (isset($_GET["version"]) ? +$_GET["version"] : 0);
$title = "Verze $version." . (isset($_GET["rand"]) ? +$_GET["rand"] : "");

header("Vary: X-Requested-With");
if ($_SERVER["HTTP_X_REQUESTED_WITH"] == "XMLHttpRequest") {
	header("X-AJAX-Title: $title");
	echo "Staženo AJAXem.\n";
} else {
	?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html lang="cs">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title><?php echo htmlspecialchars($title); ?> – Ajaxizace</title>
<link rel="stylesheet" type="text/css" href="style.css">
<body>

<ul id="menu">
<li><a href=".">Běžný web</a>
<li><a href="?version=1">Ajaxizované odkazy</a>
<li><a href="?version=2">Ajaxizované formuláře</a>
<li><a href="?version=3">jQuery plugin</a>
</ul>

<div id="loader"><img src="loader.gif" width="16" height="16" alt="nahrávání"></div>

<div id="content">

<?php
	register_shutdown_function(function () use ($version) {
		?>
</div>
<script type="text/javascript" src="jquery-1.6.4.js"></script>
<script type="text/javascript" src="version<?php echo $version; ?>.js"></script>
<?php
	});
}
?>

<h1><?php echo htmlspecialchars($title); ?></h1>
<p>Tady je obsah unikátní pro každou stránku.</p>

<h3>Odkazy</h3>
<ul>
<li><a class="no-ajaxify" href="?<?php echo ($version ? "version=$version&amp;" : ""); ?>rand=<?php echo rand(); ?>">Interní odkaz</a></li>
<li><a href="#menu">Odkaz na část stránky</a></li>
<li><a href="http://www.example.com/">Externí odkaz</a></li>
</ul>

<h3>GET formulář</h3>
<?php if (isset($_GET["search"])) { ?>
	<p>Hledali jste: „<strong><?php echo htmlspecialchars($_GET["search"]); ?></strong>“.
<?php } ?>
<form action="">
<p>
<?php if (isset($_GET["version"])) { ?><input type="hidden" name="version" value="<?php echo $version; ?>"><?php } ?>
<input name="search" value="<?php echo (isset($_GET["search"]) ? htmlspecialchars($_GET["search"]) : ""); ?>">
<input type="submit" value="Hledat">
</form>

<h3>POST formulář</h3>
<?php if ($_POST) { ?>
	<p>Uložili jste: „<strong><?php echo htmlspecialchars($_POST["data"]); ?></strong>“.
<?php } ?>
<form action="" method="post" enctype="multipart/form-data">
<p>
<input type="file" name="file">
<input name="data" value="<?php echo (isset($_POST["data"]) ? htmlspecialchars($_POST["data"]) : ""); ?>">
<input type="submit" value="Uložit">
</form>
