if (history.pushState) {
	var ajaxState = 0;
	
	function loadContent(url, data, push) {
		var currentState = ++ajaxState;
		var method = (data ? 'post' : 'get');
		$[method](url, data, function (text, status, xhr) {
			if (currentState == ajaxState && status == 'success') {
				var title = xhr.getResponseHeader('X-AJAX-Title');
				document.title = title;
				$('#content').html(text);
				if (push) {
					scrollTo(0, 0);
					history.pushState(data, title, url);
				}
			}
		});
	}
	
	$('a[href]', $('#content')).live('click', function (event) {
		var href = $(this).attr('href');
		if (!/[:#]/.test(href)) {
			loadContent(href, '', true);
			return false;
		}
	});
	
	$('input:submit').live('click', function (event) {
		var form = this.form;
		if (!$('input:file[value]', form).length) {
			var url = form.action;
			var data = $(form).serialize();
			if (this.name) { // pojmenované odesílací tlačítko
				var obj = { };
				obj[this.name] = this.value;
				data += '&' + $.param(obj);
			}
			if (!/^post$/i.test(form.method)) {
				url = url.replace(/\?.*/, '') + '?' + data;
				data = '';
			}
			loadContent(url, data, true);
			return false;
		}
	});
	
	onpopstate = function (event) {
		if (ajaxState && !/#/.test(location.href)) {
			loadContent(location.href, (event.state && confirm('Resend data?') ? event.state : ''));
		}
	};
}
