/** Ajaxify all links and forms
* @param jQuery target element for loading the data
* @param [function] called in the start of loading
* @param [function] called 
* @return jQuery fluent interface
*/
jQuery.fn.ajaxify = (function ($) {
	
	if (!history.pushState) {
		return function () {
			return this;
		}
	}
	
	return function (target, loading, loaded) {
		var areYouSure = 'Resend data?';
		var xhr;
		
		history.replaceState({ yOffset: pageYOffset }, document.title, location.href);
		
		function loadContent(url, state, push) {
			if (xhr) {
				xhr.abort();
			}
			var method = (state.data ? 'post' : 'get');
			if (loading) {
				loading();
			}
			xhr = $[method](url, state.data, function (text, status, xhr) {
				if (status == 'success') {
					var yOffset = pageYOffset;
					var title = xhr.getResponseHeader('X-AJAX-Title');
					document.title = title;
					$(target).html(text);
					if (loaded) {
						loaded();
					}
					scrollTo(0, state.yOffset);
					if (push) {
						state.yOffset = yOffset;
						history.pushState(state, title, url);
					}
				}
			});
		}
		
		onpopstate = function (event) {
			var state = event.state;
			if (state) {
				if (state.data && !confirm(areYouSure)) {
					state = { yOffset: state.yOffset };
				}
				loadContent(location.href, state);
			}
		};

		$('a[href]', this).live('click', function (event) {
			if (event.button || event.ctrlKey || event.shiftKey || event.altKey || event.metaKey) {
				return;
			}
			var href = $(this).attr('href');
			if (!/[:#]/.test(href)) {
				loadContent(href, { }, true);
				return false;
			}
		});
		
		$('input:submit', this).live('click', function (event) {
			if (event.button || event.ctrlKey || event.shiftKey || event.altKey || event.metaKey) {
				return;
			}
			var form = this.form;
			if (!$('input:file[value]', form).length) {
				var url = form.action;
				var data = $(form).serialize();
				if (this.name) { // named submit button
					var obj = { };
					obj[this.name] = this.value;
					data += '&' + $.param(obj);
				}
				if (!/^post$/i.test(form.method)) {
					url = url.replace(/\?.*/, '') + '?' + data;
					data = '';
				}
				loadContent(url, { data: data }, true);
				return false;
			}
		});
	
		return this;
	}
	
})(jQuery);

$('#content').ajaxify('#content', function () {
	$('#loader').show();
}, function () {
	$('#loader').hide();
});
